class Event(object):
	def __init__(self, name, source=None, target=None, data=None):
		self.name = name
		self.source = source
		self.target = target
		self.data = data

class EventDispatcher(object):
	def __init__(self):
		self.handlers = []
	
	def register_handler(self, handler):
		self.handlers.append(handler)
		
	def deregister_handler(self, handler):
		self.handlers.remove(handler)
	
	def trigger(self, event):
		for handler in self.handlers:
			handler.handle(event)
	
class EventHandler(object):
	def __init__(self):
		pass
		
	def handle(self, event):
		pass

