import graph
import mathutil
import random
import copy
import pyglet
import os
import data
import math
import random
import priodict
import event
import sys
from collections import deque

NOONE, PLAYER1, PLAYER2 = xrange(3)

NOONE_COLOR = (255, 255, 255, 255)
PLAYER1_COLOR = (250, 35, 35, 255)
PLAYER2_COLOR = (35, 55, 250, 255)

image_filepath = data.filepath('img')

location_img = pyglet.image.load(os.path.join(image_filepath, 'location.png'))
location_base_img = pyglet.image.load(os.path.join(image_filepath, 'location_base.png'))

anim_bin = pyglet.image.atlas.TextureBin()

p1_minion_base_img = pyglet.image.load(os.path.join(image_filepath, 'minion_red.png'))
p1_minion_base_img.anchor_x = p1_minion_base_img.width // 2
p1_minion_base_img.anchor_y = p1_minion_base_img.height // 2
p2_minion_base_img = pyglet.image.load(os.path.join(image_filepath, 'minion_blue.png'))
p2_minion_base_img.anchor_x = p2_minion_base_img.width // 2
p2_minion_base_img.anchor_y = p2_minion_base_img.height // 2

p1_minion_walk_strip = pyglet.image.load(os.path.join(image_filepath, 'minion_red_a.png'))
p1_minion_walk_seq = pyglet.image.ImageGrid(p1_minion_walk_strip, 1, 4)
p1_minion_walk_anim = pyglet.image.Animation.from_image_sequence(p1_minion_walk_seq, 0.1, True)
p1_minion_walk_anim.add_to_texture_bin(anim_bin)
for f in p1_minion_walk_anim.frames:
	f.image.anchor_x = f.image.width // 2
	f.image.anchor_y = f.image.height // 2
	
p2_minion_walk_strip = pyglet.image.load(os.path.join(image_filepath, 'minion_blue_a.png'))
p2_minion_walk_seq = pyglet.image.ImageGrid(p2_minion_walk_strip, 1, 4)
p2_minion_walk_anim = pyglet.image.Animation.from_image_sequence(p2_minion_walk_seq, 0.1, True)
p2_minion_walk_anim.add_to_texture_bin(anim_bin)
for f in p2_minion_walk_anim.frames:
	f.image.anchor_x = f.image.width // 2
	f.image.anchor_y = f.image.height // 2

p1_minion_combat_strip = pyglet.image.load(os.path.join(image_filepath, 'minion_red_c.png'))
p1_minion_combat_seq = pyglet.image.ImageGrid(p1_minion_combat_strip, 1, 3)
p1_minion_combat_anim = pyglet.image.Animation.from_image_sequence(p1_minion_combat_seq, 0.1, True)
p1_minion_combat_anim.add_to_texture_bin(anim_bin)
for f in p1_minion_combat_anim.frames:
	f.image.anchor_x = f.image.width // 2
	f.image.anchor_y = f.image.height // 2

p2_minion_combat_strip = pyglet.image.load(os.path.join(image_filepath, 'minion_blue_c.png'))
p2_minion_combat_seq = pyglet.image.ImageGrid(p2_minion_combat_strip, 1, 3)
p2_minion_combat_anim = pyglet.image.Animation.from_image_sequence(p2_minion_combat_seq, 0.1, True)
p2_minion_combat_anim.add_to_texture_bin(anim_bin)
for f in p2_minion_combat_anim.frames:
	f.image.anchor_x = f.image.width // 2
	f.image.anchor_y = f.image.height // 2

p1_hero_base_img = pyglet.image.load(os.path.join(image_filepath, 'hero_red.png'))
p1_hero_base_img.anchor_x = p1_hero_base_img.width // 2
p1_hero_base_img.anchor_y = p1_hero_base_img.height // 2
p2_hero_base_img = pyglet.image.load(os.path.join(image_filepath, 'hero_blue.png'))
p2_hero_base_img.anchor_x = p2_hero_base_img.width // 2
p2_hero_base_img.anchor_y = p2_hero_base_img.height // 2

p1_hero_walk_strip = pyglet.image.load(os.path.join(image_filepath, 'hero_red_a.png'))
p1_hero_walk_seq = pyglet.image.ImageGrid(p1_hero_walk_strip, 1, 3)
p1_hero_walk_anim = pyglet.image.Animation.from_image_sequence(p1_hero_walk_seq, 0.1, True)
p1_hero_walk_anim.add_to_texture_bin(anim_bin)
for f in p1_hero_walk_anim.frames:
	f.image.anchor_x = f.image.width // 2
	f.image.anchor_y = f.image.height // 2

p2_hero_walk_strip = pyglet.image.load(os.path.join(image_filepath, 'hero_blue_a.png'))
p2_hero_walk_seq = pyglet.image.ImageGrid(p2_hero_walk_strip, 1, 3)
p2_hero_walk_anim = pyglet.image.Animation.from_image_sequence(p2_hero_walk_seq, 0.1, True)
p2_hero_walk_anim.add_to_texture_bin(anim_bin)
for f in p2_hero_walk_anim.frames:
	f.image.anchor_x = f.image.width // 2
	f.image.anchor_y = f.image.height // 2

p1_hero_combat_strip = pyglet.image.load(os.path.join(image_filepath, 'hero_red_c.png'))
p1_hero_combat_seq = pyglet.image.ImageGrid(p1_hero_combat_strip, 1, 3)
p1_hero_combat_anim = pyglet.image.Animation.from_image_sequence(p1_hero_combat_seq, 0.1, True)
p1_hero_combat_anim.add_to_texture_bin(anim_bin)
for f in p1_hero_combat_anim.frames:
	f.image.anchor_x = f.image.width // 2
	f.image.anchor_y = f.image.height // 2

p2_hero_combat_strip = pyglet.image.load(os.path.join(image_filepath, 'hero_blue_c.png'))
p2_hero_combat_seq = pyglet.image.ImageGrid(p2_hero_combat_strip, 1, 3)
p2_hero_combat_anim = pyglet.image.Animation.from_image_sequence(p2_hero_combat_seq, 0.1, True)
p2_hero_combat_anim.add_to_texture_bin(anim_bin)
for f in p2_hero_combat_anim.frames:
	f.image.anchor_x = f.image.width // 2
	f.image.anchor_y = f.image.height // 2

p1_nest_base_img = pyglet.image.load(os.path.join(image_filepath, 'nest_red.png'))
p1_nest_base_img.anchor_x = p1_nest_base_img.width // 2
p1_nest_base_img.anchor_y = p1_nest_base_img.height // 2
p2_nest_base_img = pyglet.image.load(os.path.join(image_filepath, 'nest_blue.png'))
p2_nest_base_img.anchor_x = p2_nest_base_img.width // 2
p2_nest_base_img.anchor_y = p2_nest_base_img.height // 2

p1_base_base_img = pyglet.image.load(os.path.join(image_filepath, 'base_red.png'))
p1_base_base_img.anchor_x = p1_base_base_img.width // 2
p1_base_base_img.anchor_y = p1_base_base_img.height // 2
p2_base_base_img = pyglet.image.load(os.path.join(image_filepath, 'base_blue.png'))
p2_base_base_img.anchor_x = p2_base_base_img.width // 2
p2_base_base_img.anchor_y = p2_base_base_img.height // 2

def intersects_point(o1, x, y):
	if o1.sprite:
		sprite = o1.sprite
		
		if sprite.x <= x and sprite.x + sprite.width >= x:
			if sprite.y <= y and sprite.y + sprite.height >= y:
				return True;
		
	return False

def intersects(o1, o2):
	if o1.sprite and o2.sprite:
		s1 = o1.sprite
		s2 = o2.sprite
		
		r1 = (s1.x, s1.y, s1.x + s1.width, s1.y + s1.height)
		r2 = (s2.x, s2.y, s2.x + s2.width, s2.y + s2.height)
		
		if r1[0] >= r2[2] or r1[2] <= r2[0] or r1[1] >= r2[3] or r1[3] <= r2[1]:
			return False
		return True

def other_player(player):
	if player == PLAYER1:
		return PLAYER2
	elif player == PLAYER2:
		return PLAYER1
	return NOONE

def player_color(player):
	if player == PLAYER1:
		return PLAYER1_COLOR
	elif player == PLAYER2:
		return PLAYER2_COLOR
	return NOONE_COLOR

class Location(graph.Node):
	def __init__(self, name, x, y):
		super(Location, self).__init__(name, x, y)
		
		self.world = None
	
	def init(self):
		self.sprite = pyglet.sprite.Sprite(self.default_image, batch=self.world.batch, group=self.world.location_group)
		self.sprite.x = self.pos.x - self.sprite.width // 2
		self.sprite.y = self.pos.y - self.sprite.height // 2
		
	def cleanup(self):
		del self.sprite
	
	def update(self, dt):
		pass
	
	def __str__(self):
		return 'Location[name=%s]' % self.name

class SpawnLocation(Location):
	default_image = location_img
	
	def init(self):
		super(SpawnLocation, self).init()

		self.nest = None
	
	def update(self, dt):
		pass
					
class BaseLocation(Location):
	default_image = location_base_img
	
	def __init__(self, name, x, y, owner):
		super(Location, self).__init__(name, x, y)
		
	def init(self):
		s = pyglet.sprite.Sprite(self.default_image, batch=self.world.batch, group=self.world.location_group)
			
		self.sprite = s
		self.sprite.x = self.pos.x - self.sprite.width // 2
		self.sprite.y = self.pos.y - self.sprite.height // 2
		
	def cleanup(self):
		del self.sprite

class EntityAction(object):
	def __init__(self, entity):
		self.entity = entity
		self.done = False
	
	def enter(self):
		pass
		
	def exit(self):
		pass
	
	def pause(self):
		pass
		
	def unpause(self):
		pass
		
	def update(self, dt):
		pass

class SpawnMinionEntityAction(EntityAction):
	spawn_wait_ticks = 200
	
	def __init__(self, entity):
		super(SpawnMinionEntityAction, self).__init__(entity)
		
		self.spawn_countdown = self.spawn_wait_ticks

	def update(self, dt):
		super(SpawnMinionEntityAction, self).update(dt)
		
		self.spawn_countdown -= 1
		if self.spawn_countdown <= 0:
			entity = self.entity
			owner = self.entity.owner
			location = entity.at_location
			
			if owner != NOONE:
				base = entity.world.player_base_location(other_player(owner))
				if base:
					path = entity.world.graph.get_shortest_path(location, base)

					minion = MinionEntity('', location, owner)
					entity.world.add_entity(minion)
					minion.path = path
						
					path.reverse()
					for l in path[:-1]:
						action = TravelEntityAction(minion, l)
						minion.push_action(action)
			
			self.spawn_countdown = self.spawn_wait_ticks

class WaitEntityAction(EntityAction):
	def __init__(self, entity, countdown=100):
		super(WaitEntityAction, self).__init__(entity)
		
		self.countdown = countdown

	def update(self, dt):
		super(WaitEntityAction, self).update(dt)
		
		self.countdown -= 1
		if self.countdown <= 0:
			self.done = True
		
class SpawnNestEntityAction(EntityAction):
	spawn_wait_ticks = 300
	
	@classmethod
	def get_spawn_wait_ticks(cls):
		return cls.spawn_wait_ticks
	
	def __init__(self, entity):
		super(SpawnNestEntityAction, self).__init__(entity)
		
		self.spawn_countdown = self.spawn_wait_ticks

	def update(self, dt):
		super(SpawnNestEntityAction, self).update(dt)
		
		self.spawn_countdown -= 1
		if self.spawn_countdown <= 0:
			entity = self.entity
			owner = self.entity.owner
			location = entity.at_location
		
			if location and location.nest is None:
				nest = NestEntity('', location, owner)
				entity.world.add_entity(nest)
				location.nest = nest
				
			self.spawn_countdown = self.spawn_wait_ticks
			
			self.done = True

class TravelEntityAction(EntityAction):
	def __init__(self, entity, to_location):
		super(TravelEntityAction, self).__init__(entity)
		self.to_location = to_location
		
	def update(self, dt):
		super(TravelEntityAction, self).update(dt)

		#if self.entity.sprite != type(self.entity).get_walk_img(self.entity.owner):
		#	self.entity.sprite = pyglet.sprite.Sprite(type(self.entity).get_walk_img(self.entity.owner))

		vec = self.to_location.pos.subtract(self.entity.pos)
		vec.normalize_ip().scale_ip(self.entity.speed).scale_ip(dt)
		
		if self.to_location.pos.subtract(self.entity.pos).mag < vec.mag:
			self.entity.at_location = self.to_location
			self.entity.to_location = None
			self.entity.from_location = None
			self.entity.location_history.append(self.entity.at_location)
			self.entity.pos.x = self.entity.at_location.pos.x
			self.entity.pos.y = self.entity.at_location.pos.y
			self.entity._on_enter_location()
			self.done = True
		else:
			self.entity.pos.add_ip(vec)
			
			if self.entity.at_location:
				self.entity.from_location = self.entity.at_location
				self.entity.at_location = None
				self.entity.to_location = self.to_location
				self.entity._on_exit_location()

				rad = math.atan2(self.to_location.pos.y - self.entity.pos.y, 
								 self.to_location.pos.x - self.entity.pos.x) - math.atan2(0, 1)				
				self.entity.sprite.rotation = math.degrees(rad) * -1
				
			self._calc_sprite_rotation()
			
	def unpause(self):
		self.entity.create_sprite(type(self.entity).get_walk_img(self.entity.owner))
		
	def _calc_sprite_rotation(self):
		rad = math.atan2(self.to_location.pos.y - self.entity.pos.y, 
						self.to_location.pos.x - self.entity.pos.x) - math.atan2(0, 1)				
		self.entity.sprite.rotation = math.degrees(rad) * -1
	
	def enter(self):
		self.entity.create_sprite(type(self.entity).get_walk_img(self.entity.owner))
	
	def exit(self):
		self.entity.create_sprite(type(self.entity).get_base_img(self.entity.owner))
	
class CombatEntityAction(EntityAction):
	def __init__(self, entity, other_entity):
		super(CombatEntityAction, self).__init__(entity)
		self.other_entity = other_entity
		self.max_cooldown_ticks = 15
		self.cooldown_ticks = self.max_cooldown_ticks
		
	def update(self, dt):
		super(CombatEntityAction, self).update(dt)

		if self.other_entity not in self.entity.coll_entities:
			self.done = True
			return
			
		if self.other_entity not in self.entity.world.entities:
			self.done = True
			return

		self.cooldown_ticks -= 1

		if self.cooldown_ticks <= 0:
			attack_strength_range = self.entity.attack_strength_range
			attack_strength = random.randint(attack_strength_range[0], attack_strength_range[1])
			
			self.other_entity.health -= attack_strength
			self.other_entity.on_receive_damage(self.entity)
			if self.other_entity.health <= 0:
				self.entity.world.remove_entity(self.other_entity)
				self.done = True
				
			self.cooldown_ticks = self.max_cooldown_ticks

		self._calc_sprite_rotation()
	def unpause(self):
		self.entity.create_sprite(type(self.entity).get_combat_img(self.entity.owner))
		
	def _calc_sprite_rotation(self):
		rad = math.atan2(self.other_entity.pos.y - self.entity.pos.y, 
						self.other_entity.pos.x - self.entity.pos.x) - math.atan2(0, 1)				
		self.entity.sprite.rotation = math.degrees(rad) * -1
		
	def enter(self):
		self.entity.create_sprite(type(self.entity).get_combat_img(self.entity.owner))
		
	def exit(self):
		self.entity.create_sprite(type(self.entity).get_base_img(self.entity.owner))

class EntityActionStrategy(object):
	def __init__(self, entity):
		self.entity = entity
		
	def on_no_action(self):
		return None
		
	def on_exit_location(self):
		pass
		
	def on_enter_location(self):
		pass
	
	def on_enter_entity_collission(self, other):
		pass
	
	def on_exit_entity_collission(self, other):
		pass
		
	def on_heal(self):
		pass
		
	def on_receive_damage(self, other):
		pass
		
class RandomTravelActionStrategy(EntityActionStrategy):
	def __init__(self, entity):
		super(RandomTravelActionStrategy, self).__init__(entity)
		self.entity = entity
		
	def on_no_action(self):
		super(RandomTravelActionStrategy, self).on_no_action()
		
		entity = self.entity
		
		available_locations = []
		if entity.at_location:
			available_locations = entity.world.graph.get_node_connections(entity.at_location)
		elif entity.to_location:
			available_locations.append(entity.to_location)
		
		if len(available_locations):
			destination = random.choice(available_locations)
			action = TravelEntityAction(entity, destination)
			self.entity.push_action(action)	
			
class HeroActionStrategy(EntityActionStrategy):
	def __init__(self, entity):
		super(HeroActionStrategy, self).__init__(entity)
		self.entity = entity
		
		self.nest_priority = 0
		self.defend_priority = 0
		self.attack_priority = 0
		self.flee_priority = 0
		
		self.nest_w = 1
		self.defend_w = 1
		self.attack_w = 1
		self.flee_w = 1
		self.distance_w = 0.3
		
		self.flee_offending_entity = None
		self.nest_target = None
		
		self.selected_nest_target = None
		
	def _analyze(self):	
		entity = self.entity
		world = entity.world
		graph = world.graph
		owner = self.entity.owner
		enemy_owner = other_player(owner)
		enemy_hero = world.player_hero(enemy_owner)
		my_base = world.player_base_location(owner)
		enemy_base = world.player_base_location(enemy_owner)
		
		if my_base is None or enemy_base is None:
			return
			
		self.enemy_nests = []
		self.my_nests = []
		for entity in world.entities:
			if isinstance(entity, NestEntity):
				if entity.owner == owner:
					self.my_nests.append(entity)
				else:
					self.enemy_nests.append(entity)
					
		print 'my nests: %s' % len(self.my_nests)
		print 'enemy nests: %s' % len(self.enemy_nests)
		
		self.enemy_location_threat_dict = {}
		self.my_location_threat_dict = {}
		
		self.my_location_strategic_value_dict = {}
		
		for location in world.locations:
			self.enemy_location_threat_dict[location] = 0
			self.my_location_threat_dict[location] = 0
			
		for nest in self.enemy_nests:
			path = graph.get_shortest_path(nest.at_location, my_base)
			path_mod = 0
			for l in path:
				for n in self.my_nests:		
					if n.at_location == l:
						path_mod += 1
						break
				t = self.enemy_location_threat_dict[l]
				self.enemy_location_threat_dict[l] = t + 1 - path_mod
				
		for nest in self.my_nests:
				path = graph.get_shortest_path(nest.at_location, enemy_base)
				path_mod = 0
				for l in path:
					for n in self.enemy_nests:		
						if n.at_location == l:
							path_mod += 1
							break
					t = self.my_location_threat_dict[l]
					self.my_location_threat_dict[l] = t + 1 - path_mod
		
		for location in world.locations:
			self.my_location_strategic_value_dict[location] = self.my_location_threat_dict[location] - self.enemy_location_threat_dict[location]
		
		# find the ideal place to nest
		sv_max = -10000
		sv_min = 10000
			
		sv_max_loc = None
		sv_min_loc = None			
			
		ref_location = entity.at_location
		if not ref_location:
			ref_location = entity.to_location
				
		assert ref_location
			
		for location in world.locations:
			if isinstance(location, BaseLocation):
				continue
					
			if location.nest:
				continue
				
			sv = self.my_location_strategic_value_dict[location]
				
			path = graph.get_shortest_path(ref_location, location)
			dm = (len(path) - 1) * self.distance_w
			
			print dm
			
			sv += dm
						
			if sv > sv_max:
				sv_max = sv
				sv_max_loc = location
						
			if sv < sv_min:
				sv_min = sv
				sv_min_loc = location
			
		target = None
		if sv_max > abs(sv_min):
			print 'picking def over off nest location'
			target = sv_min_loc
		else:
			print 'picking off over def nest location'
			target = sv_max_loc
							
		self.nest_target = target
		
		#for l, t in self.my_location_strategic_value_dict.iteritems():
		#	print '-> %s [%s]' % (l.name, t)
			
		#self.possible_nest_location_path_dict = {}
	
	def _strategize(self):
		entity = self.entity
		world = entity.world
		graph = world.graph
		owner = self.entity.owner
		enemy_owner = other_player(owner)
		enemy_hero = world.player_hero(enemy_owner)
		my_base = world.player_base_location(owner)
		enemy_base = world.player_base_location(enemy_owner)
		my_points = world.player_attributes(owner).points
	
		if my_base is None or enemy_base is None:
			return

		self._analyze()
		self._calc_flee_priority()
		self._calc_nest_priority()

		print 'flee p: %s ' % self.flee_priority
		print 'nest p: %s ' % self.nest_priority

		do_flee = False
		do_nest = False

		if self.flee_priority > self.nest_priority:
			do_flee = True
			self.selected_nest_target = False
		else:
			if self.nest_target or self.selected_nest_target:
				if not self.selected_nest_target:
					self.selected_nest_target = self.nest_target
				do_nest = True

		if not do_flee:
			self.flee_offending_entity = None
		if not do_nest:	
			self.selected_nest_target = None
		
		if do_nest:
				if self.selected_nest_target:
					self.selected_nest_target = self.nest_target
					
				print 'self.selected_nest_target: %s' % self.selected_nest_target.name
				
				if entity.at_location and entity.at_location == self.selected_nest_target:
					print 'ok we can create the nest'
					if not entity.create_nest():
						print 'couldnt nest -what to do?'
						#self.selected_nest_target = None
						return
					else:
						#self.selected_nest_target = None
						return
						
				entity.move_to(self.selected_nest_target)
				return
		
		if do_flee:
			if self.flee_offending_entity:
				oe_at_location = self.flee_offending_entity.at_location
				oe_from_location = self.flee_offending_entity.from_location
				oe_to_location = self.flee_offending_entity.to_location
				
				if oe_to_location:
					if entity.to_location:
						if entity.to_location == oe_to_location:
							entity.move_to(entity.from_location) # go back where I came from
							return
						if entity.from_location == oe_to_location:
							entity.move_to(entity.to_location) # go back where I came from
							return					
				
				if oe_at_location:
					if entity.to_location:
						if entity.to_location == oe_at_location:
							entity.move_to(entity.from_location) # go back where I came from
							return
						if entity.from_location == oe_at_location:
							entity.move_to(entity.to_location) # escape to base
							return				
			
			in_progress = entity.at_location is not None and entity.at_location == my_base
			if not in_progress:
				in_progress = entity.to_location is not None and entity.to_location == my_base
			
			if not in_progress:
				entity.move_to(my_base)
			else:
				if entity.health < entity.health_max:
					self._calc_flee_priority()
				else:
					self.flee_piority = 0
			return

		#print 'nothing to do'

		# if nothing, move randomly
		#available_locations = []
		#if entity.at_location:
		#	available_locations = graph.get_node_connections(entity.at_location)
		#elif entity.to_location:
		#	available_locations.append(entity.to_location)
		
		#if len(available_locations):
		#	destination = random.choice(available_locations)
		#	action = TravelEntityAction(entity, destination)
		#	self.entity.push_action(action)
	
	def on_no_action(self):
		super(HeroActionStrategy, self).on_no_action()
		self._strategize()
	
	def on_heal(self):
		super(HeroActionStrategy, self).on_heal()
		#self._strategize()
		
	def on_receive_damage(self, other):
		super(HeroActionStrategy, self).on_receive_damage(other)
		
		entity = self.entity
		
		if float(entity.health) / entity.health_max < 0.3:
			if entity.to_location: # if we are moving
				self.flee_offending_entity = other
			
			self._strategize()
	
	def on_exit_location(self):
		super(HeroActionStrategy, self).on_exit_location()
		
	def on_enter_location(self):
		super(HeroActionStrategy, self).on_enter_location()
		
		self.flee_offending_entity = None
	
	def on_enter_entity_collission(self, other):
		super(HeroActionStrategy, self).on_enter_entity_collission(other)
	
	def on_exit_entity_collission(self, other):
		super(HeroActionStrategy, self).on_exit_entity_collission(other)
	
	def _calc_nest_priority(self):
		entity = self.entity
		world = entity.world
		owner = self.entity.owner
		enemy_owner = other_player(owner)
		enemy_hero = world.player_hero(enemy_owner)
		my_base = world.player_base_location(owner)
		my_points = world.player_attributes(owner).points
		
		if my_points >= NestEntity.get_point_cost():
			self.nest_priority = 40
		else:
			self.nest_priority = 0
	
	def _calc_flee_priority(self):
		entity = self.entity
		world = entity.world
		owner = self.entity.owner
		enemy_owner = other_player(owner)
		enemy_hero = world.player_hero(enemy_owner)
		my_base = world.player_base_location(owner)

		self.flee_priority = int((entity.health_max - entity.health) * 0.1)
		
		if enemy_hero:
			if enemy_hero.to_location and enemy_hero.to_location == my_base:
				self.flee_priority = 50

class Entity(object):
	p1_base_img = pyglet.image.SolidColorImagePattern(color=(100, 0, 0, 255)).create_image(15, 15)
	p2_base_img = pyglet.image.SolidColorImagePattern(color=(0, 0, 100, 255)).create_image(15, 15)
	p1_walk_img = p1_base_img
	p2_walk_img = p2_base_img
	p1_combat_img = p1_base_img
	p2_combat_img = p2_base_img
	
	point_cost = 0
	
	@classmethod
	def get_point_cost(cls):
		return cls.point_cost
		
	@classmethod
	def get_base_img(cls, player):
		if player == PLAYER1:
			return cls.p1_base_img
		return cls.p2_base_img
		
	@classmethod
	def get_walk_img(cls, player):
		if player == PLAYER1:
			return cls.p1_walk_img
		return cls.p2_walk_img
	
	@classmethod
	def get_combat_img(cls, player):
		if player == PLAYER1:
			return cls.p1_combat_img
		return cls.p2_combat_img
	
	def __init__(self, name, location, owner):
		self.name = name
		self.at_location = location
		self.to_location = None
		self.from_location = None
		self.pos = mathutil.Vector2D(location.pos.x, location.pos.y)
		
		self.owner = owner
		
		self.world = None
		
		self.speed = 50
		self.attack_strength_range = None
		
		self.action_strategy = None
		self.action_stack = []
		self.location_history = deque([], 3)
		
		self.health_max = 20		
		self.point_worth = 0
		
	def init(self):
		self.sprite = None
		#s = pyglet.sprite.Sprite(self.p1_base_img)
		#if self.owner == PLAYER2:
			#s = pyglet.sprite.Sprite(self.p2_base_img)
		
		#self.sprite = s
		#self._update_sprite()
		
		self.coll_entities = []
		
		self.health = self.health_max
		
	def cleanup(self):
		pass
	
	def update(self, dt):
		if len(self.action_stack) == 0:
			self._on_no_action()
		else:
			action = self.action_stack[-1]
			action.update(dt)
			if action.done:
				if len(self.action_stack):
					self.action_stack.pop().exit()
					if len(self.action_stack):
						self.action_stack[-1].unpause()
						
		self._update_sprite()
	
	def clear_actions(self):
		self.action_stack = []
		
	def push_action(self, action):
		if len(self.action_stack) > 0:
			self.action_stack[-1].pause()
		self.action_stack.append(action)
		action.enter()
		
	def pop_action(self):
		if len(self.action_stack) > 0:
			result = self.action_stack.pop()
			if len(self.action_stack) > 0:
				self.action_stack[-1].unpause()
			return result
		return None
	
	def _update_sprite(self):
		s = self.sprite
		if s:
			s.x = self.pos.x
			s.y = self.pos.y
	
	def _on_die(self):
		if self.point_worth:
			self.world.award_points_to_player(self, other_player(self.owner), self.point_worth)
	
	def _on_no_action(self):
		if self.action_strategy:
			self.action_strategy.on_no_action()

	def _on_exit_location(self):
		if self.action_strategy:
			self.action_strategy.on_exit_location()
		
	def _on_enter_location(self):
		if self.action_strategy:
			self.action_strategy.on_enter_location()
	
	def on_enter_entity_collission(self, other):
		if self.attack_strength_range is not None:
			if self.owner != other.owner:
				action = CombatEntityAction(self, other)
				self.push_action(action)
				
		if self.action_strategy:
			self.action_strategy.on_enter_entity_collission(other)
	
	def on_exit_entity_collission(self, other):
		if self.action_strategy:
			self.action_strategy.on_exit_entity_collission(other)
			
	def on_heal(self):
		if self.action_strategy:
			self.action_strategy.on_heal()
	
	def on_receive_damage(self, other):
		if self.action_strategy:
			self.action_strategy.on_receive_damage(other)
	
	def _get_previous_location(self):
		if self.at_location:
			if len(self.location_history) > 1:
				return self.location_history[-2]
		else:
			if len(self.location_history) > 0:
				return self.location_history[-1]
		return None
	
	def get_available_actions(self):
		results = []
		available_move_locations = self._get_avaiable_move_locations()
		for location in available_move_locations:
			results.append(TravelEntityAction(self, location))
		return results
	
	def _get_avaiable_move_locations(self):
		if self.at_location:
			return self.world.graph.get_node_connections(self.at_location)
		return []
	
	def get_group(self):
		return None
		
	def create_sprite(self, img):
		os = self.sprite
		if os:
			os.delete()
		
		g = self.get_group()
		self.sprite = pyglet.sprite.Sprite(img, batch=self.world.batch, group=g)
		
		self._update_sprite()

class PassiveEntity(Entity):
	def __init__(self, name, location, owner):
		super(PassiveEntity, self).__init__(name, location, owner)
		
		self.speed = 0

class MobileEntity(Entity):
	def __init__(self, name, location, owner):
		super(MobileEntity, self).__init__(name, location, owner)

	def move_to(self, destination):
		path = None
		last_action = None
		if self.to_location:
			last_action = TravelEntityAction(self, self.to_location)
			path = self.world.graph.get_shortest_path(self.to_location, destination)
		elif self.at_location:
			if self.at_location != destination:
				path = self.world.graph.get_shortest_path(self.at_location, destination)
			else:
				return
		else:
			return
		
		if len(path):	
			self.clear_actions()
			path.reverse()
		
			for l in path[:-1]:
				action = TravelEntityAction(self, l)
				self.push_action(action)
				
			if last_action:
				self.push_action(last_action)
		
		def _on_enter_location(self):
			super(MobileEntity, self)._on_enter_location()

class HeroEntity(MobileEntity):
	p1_base_img = p1_hero_base_img
	p1_walk_img = p1_hero_walk_anim
	p2_base_img = p2_hero_base_img
	p2_walk_img = p2_hero_walk_anim
	p1_combat_img = p1_hero_combat_anim
	p2_combat_img = p2_hero_combat_anim
	
	def __init__(self, name, location, owner):
		super(HeroEntity, self).__init__(name, location, owner)

		self.attack_strength_range = (8, 10)
		
		self.health_max = 200
		
		self.point_worth = 50

	def init(self):
		super(HeroEntity, self).init()
		
		if self.owner == PLAYER1:
			self.create_sprite(self.p1_base_img)
		if self.owner == PLAYER2:
			self.create_sprite(self.p2_base_img)

		self._update_sprite()
		
		self.health = self.health_max
	
	def can_nest(self):
		l = self.at_location
		if l:
			if isinstance(l, SpawnLocation):
				if l.nest == None:
					for action in self.action_stack:
						if isinstance(action, SpawnNestEntityAction):
							return False
							
					if self.world.player_attributes(self.owner).points < NestEntity.get_point_cost():
						return False
												
					return True
		return False
	
	def create_nest(self):
		if self.can_nest():
		
			self.clear_actions()
		
			self.world.subtract_points_from_player(self, self.owner, NestEntity.get_point_cost())
		
			action = SpawnNestEntityAction(self)
			self.push_action(action)		
		
			return True
		return False
		
	def get_group(self):
		return self.world.hero_group

class MinionEntity(MobileEntity):
	p1_base_img = p1_minion_base_img
	p1_walk_img = p1_minion_walk_anim
	p2_base_img = p1_minion_base_img
	p2_walk_img = p2_minion_walk_anim
	p1_combat_img = p1_minion_combat_anim
	p2_combat_img = p2_minion_combat_anim
	
	def __init__(self, name, location, owner):
		super(MinionEntity, self).__init__(name, location, owner)
		
		self.attack_strength_range = (1, 3)
		
		self.point_worth = 0

	def init(self):
		super(MinionEntity, self).init()
		
		if self.owner == PLAYER1:
			self.create_sprite(self.p1_base_img)
		if self.owner == PLAYER2:
			self.create_sprite(self.p2_base_img)
			
		self._update_sprite()

	def _on_enter_location(self):
		super(MinionEntity, self)._on_enter_location()
		
		if not self.world.game_over:
			if isinstance(self.at_location, BaseLocation):
				self.world.remove_entity(self)
	
	def get_group(self):
		return self.world.minion_group
	
	def __str__(self):
		return 'Minion[%s]' % id(self)

class NestEntity(PassiveEntity):
	point_cost = 60
	award_point_cooldown = 50
	
	p1_base_img = p1_nest_base_img
	p2_base_img = p2_nest_base_img
	
	def __init__(self, name, location, owner):
		super(NestEntity, self).__init__(name, location, owner)

		self.health_max = 250
		
		self.point_worth = 15

	def init(self):
		super(NestEntity, self).init()
		if self.owner == PLAYER1:
			self.create_sprite(self.p1_base_img)
		if self.owner == PLAYER2:
			self.create_sprite(self.p2_base_img)
			
		self._update_sprite()
		
		self.health = self.health_max
		
		self.award_point_countdown = self.award_point_cooldown
	
	def _on_die(self):
		super(NestEntity, self)._on_die()
		
		self.at_location.nest = None
	
	def _on_no_action(self):
		super(NestEntity, self)._on_no_action()
		
		self.push_action(SpawnMinionEntityAction(self))
		
	def update(self, dt):
		super(NestEntity, self).update(dt)
		
		self.award_point_countdown -= 1
		if self.award_point_countdown <= 0:
			self.award_point_countdown = self.award_point_cooldown
						
			self.world.award_points_to_player(self, self.owner, 1)

	def get_group(self):
		return self.world.nest_group

class BaseEntity(PassiveEntity):
	heal_cooldown = 8
	award_point_cooldown = 50
	
	p1_base_img = p1_base_base_img
	p2_base_img = p2_base_base_img
	p1_combat_img = p1_base_img
	p2_combat_img = p2_base_img
	
	def __init__(self, name, location, owner):
		super(BaseEntity, self).__init__(name, location, owner)
		
		self.attack_strength_range = (6, 8)
		
		self.health_max = 600

	def init(self):
		super(BaseEntity, self).init()
		if self.owner == PLAYER1:
			self.create_sprite(self.p1_base_img)
		if self.owner == PLAYER2:
			self.create_sprite(self.p2_base_img)

		self._update_sprite()
		
		self.health = self.health_max
		
		self.heal_countdown = self.heal_cooldown
		self.award_point_countdown = self.award_point_cooldown
		
	def update(self, dt):
		super(BaseEntity, self).update(dt)
		
		self.heal_countdown -= 1
		if self.heal_countdown <= 0:
			self.heal_countdown = self.heal_cooldown
			
			hero = self.world.player_hero(self.owner)
			if hero and hero.at_location:
				if hero.at_location == self.at_location:
					if hero.health < hero.health_max:
						hero.health += 1
						hero.on_heal()
						
		self.award_point_countdown -= 1
		if self.award_point_countdown <= 0:
			self.award_point_countdown = self.award_point_cooldown
						
			self.world.award_points_to_player(self, self.owner, 1)

class PlayerAttributes(object):
	def __init__(self):
		self.points = 180

class World(event.EventDispatcher):
	revive_hero_cooldown = 800
	
	def __init__(self, graph, left_player, human_player, entities=[]):
		super(World, self).__init__()
		self.graph = graph
		self.entities = list(entities)
		
		self.left_player = left_player
		self.human_player = human_player
		
		for l in self.locations:
			l.world = self
			
		for e in self.entities:
			e.world = self

	@property
	def locations(self):
		return tuple(self.graph._dict.keys())
		
	def init(self):
		self.graph.cache_paths()
		
		self.batch = pyglet.graphics.Batch()
		self.location_group = pyglet.graphics.OrderedGroup(0)
		self.nest_group = pyglet.graphics.OrderedGroup(1)
		self.minion_group = pyglet.graphics.OrderedGroup(2)
		self.hero_group = pyglet.graphics.OrderedGroup(3)
		
		self.player_attributes_dict = {}
		self.player_attributes_dict[PLAYER1] = PlayerAttributes()
		self.player_attributes_dict[PLAYER2] = PlayerAttributes()
		
		for l in self.locations:
			l.init()
			
		for e in self.entities:
			e.init()
			
		self.revive_p1_hero_countdown = 0
		self.revive_p2_hero_countdown = 0
		
		self.game_over = False
		self.losing_player = NOONE
		self.winning_player = NOONE
	
	def update(self, dt):
		for l in self.locations:
			l.update(dt)
		
		if not self.game_over:
			coll_pairs_dict = {}
			for e in self.entities:
				for oe in self.entities:
					if e == oe:
						continue
					if oe in coll_pairs_dict.keys():
						continue
					if intersects(e, oe):					
						if e not in coll_pairs_dict.keys():
							coll_pairs_dict[e] = [oe]	
						else:
							coll_pairs_dict[e].append(oe)
						
						if oe not in coll_pairs_dict.keys():
							coll_pairs_dict[oe] = [e]
						else:
							coll_pairs_dict[oe].append(e)

		for e in self.entities:
			if not self.game_over:
				e_coll_list = coll_pairs_dict.get(e, [])
				
				enter_coll_list = list(set(e_coll_list) - set(e.coll_entities))
				for oe in enter_coll_list:
					e.on_enter_entity_collission(oe)
								
				exit_coll_list = list(set(e.coll_entities) - set(e_coll_list))
				for oe in exit_coll_list:
					e.on_exit_entity_collission(oe)

				e.coll_entities = e_coll_list
			
			e.update(dt)
		
		if not self.game_over:
			if self.revive_p1_hero_countdown > 0:
				self.revive_p1_hero_countdown -= 1
				if self.revive_p1_hero_countdown <= 0:
					# revive
					base_location = self.player_base_location(PLAYER1)
					if base_location:				
						hero = HeroEntity('', base_location, PLAYER1)
						if self.human_player != PLAYER1:
							hero.action_strategy = HeroActionStrategy(hero)
						self.add_entity(hero)
			else:
				p1_hero = self.player_hero(PLAYER1)
				if not p1_hero:
					self.revive_p1_hero_countdown = self.revive_hero_cooldown
					
			if self.revive_p2_hero_countdown > 0:
				self.revive_p2_hero_countdown -= 1
				if self.revive_p2_hero_countdown <= 0:
					# revive
					base_location = self.player_base_location(PLAYER2)
					if base_location:				
						hero = HeroEntity('', base_location, PLAYER2)
						if self.human_player != PLAYER2:
							hero.action_strategy = HeroActionStrategy(hero)
						self.add_entity(hero)
			else:
				p2_hero = self.player_hero(PLAYER2)
				if not p2_hero:
					self.revive_p2_hero_countdown = self.revive_hero_cooldown

	def cleanup(self):
		for l in self.locations:
			l.cleanup()
			
		for e in self.entities:
			e.cleanup()
	
	def add_entity(self, entity):
		self.entities.append(entity)
		entity.world = self
		
		entity.init()
		
	def remove_entity(self, entity):
		self.entities.remove(entity)
		
		entity._on_die()
		entity.world = None
		if entity.sprite:
			entity.sprite.delete()
		entity.sprite = None
		
		entity.cleanup()
		
		if isinstance(entity, BaseEntity):
			self.losing_player = entity.owner
			self.winning_player = other_player(entity.owner)
			
			self.game_over = True
			
			for e in self.entities:
				if e.owner == self.losing_player:
					self.remove_entity(e)
				else:
					e.clear_actions()
					#e.owner = NOONE
					e.action_strategy = RandomTravelActionStrategy(e)
	
	def player_base(self, player):
		if player == NOONE:
			return None
		for e in self.entities:
			if isinstance(e, BaseEntity):
				if e.owner == player:
					return e
		return None
	
	def player_base_location(self, player):
		base = self.player_base(player)
		if base:
			return base.at_location
		return None
		
	def player_hero(self, player):
		if player == NOONE:
			return None
		for e in self.entities:
			if isinstance(e, HeroEntity):
				if e.owner == player:
					return e
		return None
		
	def player_attributes(self, player):
		return self.player_attributes_dict[player]
		
	def award_points_to_player(self, source, player, amount):
		attribs = self.player_attributes_dict.get(player, None)
		if attribs:
			attribs.points += amount
			self.trigger(event.Event('POINT_AWARD', source, player, amount))
		
	def subtract_points_from_player(self, source, player, amount):
		attribs = self.player_attributes_dict.get(player, None)
		if attribs:
			attribs.points -= amount
		
		print 'subtracting %s from player %s' % (amount, player)
		
